# Microsemi Tcl Script
# LiberoSoC 12.6
# Date: Wed Feb 11 09:36:30 2021
# Directory C:\Mchpprj\Smartfusion2_Fabric
# File C:\Mchpprj\Smartfusion2_Fabric\BuildDesign_11feb21_0936.tcl
#
# Luca Cattaneo
# version 1.0
#
# Fabric_Top_11feb21_0936

set import_dir "C:/Mchpprj/SF2_Fab_Probe/Source_files"

set project_folder_name Smartfusion2_Fabric
set Libero_project_name Smartfusion2_Fabric
set project_dir "./$project_folder_name"

set toplevel {Fabric_Top}
set currdate "_11feb21_0936"

set prog_filename $toplevel$currdate

puts "-------------------------------------------------------------------------"
puts "-----------------------CREATING NEW PROJECT------------------------------"
puts "-------------------------------------------------------------------------"

new_project -location ${project_dir} -name ${Libero_project_name} -project_description {test design ${currdate} } -block_mode 0 -standalone_peripheral_initialization 0 -instantiate_in_smartdesign 1 \
-ondemand_build_dh 1 -use_relative_path 0 -linked_files_root_dir_env {} -hdl {VHDL} -family {SmartFusion2} -die {M2S010} -package {400 VF} -speed {STD} \
-die_voltage {1.2} -part_range {COM} -adv_options {DSW_VCCA_VOLTAGE_RAMP_RATE:100_MS} -adv_options {IO_DEFT_STD:LVCMOS 3.3V} \
-adv_options {PLL_SUPPLY:PLL_SUPPLY_33} -adv_options {RESTRICTPROBEPINS:1} -adv_options {RESTRICTSPIPINS:0} -adv_options {SYSTEM_CONTROLLER_SUSPEND_MODE:0} \
-adv_options {TEMPR:COM} -adv_options {VCCI_1.2_VOLTR:COM} -adv_options {VCCI_1.5_VOLTR:COM} -adv_options {VCCI_1.8_VOLTR:COM} -adv_options {VCCI_2.5_VOLTR:COM} \
-adv_options {VCCI_3.3_VOLTR:COM} -adv_options {VOLTR:COM} 

import_files \
         -convert_EDN_to_HDL 0 \
         -library {work} \
         -hdl_source ${import_dir}/count24.vhd

create_smartdesign -sd_name ${toplevel}
build_design_hierarchy 
create_hdl_core -file hdl/count24.vhd -module {count24} -library {work} -package {} 
sd_instantiate_hdl_core -sd_name ${toplevel} -hdl_core_name {count24} -instance_name {count24_0} 

create_and_configure_core -core_vlnv {Actel:SgCore:FCCC:2.0.201} -component_name {FCCC_C0} \
-params {"ADVANCED_TAB_CHANGED:false" "CLK0_IS_USED:false" "CLK0_PAD_IS_USED:false" "CLK1_IS_USED:false" "CLK1_PAD_IS_USED:false" "CLK2_IS_USED:false" "CLK2_PAD_IS_USED:false" \
"CLK3_IS_USED:false" "CLK3_PAD_IS_USED:false" "DYN_CONF_IS_USED:false" "GL0_BP_IN_0_FREQ:100" "GL0_BP_IN_0_SRC:IO_HARDWIRED_0" "GL0_BP_IN_1_FREQ:100" \
"GL0_BP_IN_1_SRC:IO_HARDWIRED_0" "GL0_FREQUENCY_LOCKED:false" "GL0_IN_0_SRC:PLL" "GL0_IN_1_SRC:UNUSED" "GL0_IS_INVERTED:false" "GL0_IS_USED:true" "GL0_OUT_0_FREQ:1" \
"GL0_OUT_1_FREQ:50" "GL0_OUT_IS_GATED:false" "GL0_PLL_IN_0_PHASE:0" "GL0_PLL_IN_1_PHASE:0" "GL1_BP_IN_0_FREQ:100" "GL1_BP_IN_0_SRC:IO_HARDWIRED_0" "GL1_BP_IN_1_FREQ:100" \
"GL1_BP_IN_1_SRC:IO_HARDWIRED_0" "GL1_FREQUENCY_LOCKED:false" "GL1_IN_0_SRC:PLL" "GL1_IN_1_SRC:UNUSED" "GL1_IS_INVERTED:false" "GL1_IS_USED:false" "GL1_OUT_0_FREQ:100" \
"GL1_OUT_1_FREQ:50" "GL1_OUT_IS_GATED:false" "GL1_PLL_IN_0_PHASE:0" "GL1_PLL_IN_1_PHASE:0" "GL2_BP_IN_0_FREQ:100" "GL2_BP_IN_0_SRC:IO_HARDWIRED_0" "GL2_BP_IN_1_FREQ:100" \
"GL2_BP_IN_1_SRC:IO_HARDWIRED_0" "GL2_FREQUENCY_LOCKED:false" "GL2_IN_0_SRC:PLL" "GL2_IN_1_SRC:UNUSED" "GL2_IS_INVERTED:false" "GL2_IS_USED:false" "GL2_OUT_0_FREQ:100" \
"GL2_OUT_1_FREQ:50" "GL2_OUT_IS_GATED:false" "GL2_PLL_IN_0_PHASE:0" "GL2_PLL_IN_1_PHASE:0" "GL3_BP_IN_0_FREQ:100" "GL3_BP_IN_0_SRC:IO_HARDWIRED_0" "GL3_BP_IN_1_FREQ:100" \
"GL3_BP_IN_1_SRC:IO_HARDWIRED_0" "GL3_FREQUENCY_LOCKED:false" "GL3_IN_0_SRC:PLL" "GL3_IN_1_SRC:UNUSED" "GL3_IS_INVERTED:false" "GL3_IS_USED:false" "GL3_OUT_0_FREQ:100" \
"GL3_OUT_1_FREQ:50" "GL3_OUT_IS_GATED:false" "GL3_PLL_IN_0_PHASE:0" "GL3_PLL_IN_1_PHASE:0" "GPD0_IS_USED:true" "GPD0_NOPIPE_RSTSYNC:true" "GPD0_SYNC_STYLE:G3STYLE_AND_LOCK_RSTSYNC" \
"GPD1_IS_USED:false" "GPD1_NOPIPE_RSTSYNC:true" "GPD1_SYNC_STYLE:G3STYLE_AND_NO_LOCK_RSTSYNC" "GPD2_IS_USED:false" "GPD2_NOPIPE_RSTSYNC:true" \
"GPD2_SYNC_STYLE:G3STYLE_AND_NO_LOCK_RSTSYNC" "GPD3_IS_USED:false" "GPD3_NOPIPE_RSTSYNC:true" "GPD3_SYNC_STYLE:G3STYLE_AND_NO_LOCK_RSTSYNC" "GPD_EXPOSE_RESETS:false" \
"GPD_SYNC_STYLE:G3STYLE_AND_LOCK_RSTSYNC" "INIT:0000007FA8000045574000718C6318C2318C1DEC0404045000104" "IO_HARDWIRED_0_IS_DIFF:false" "IO_HARDWIRED_1_IS_DIFF:false" \
"IO_HARDWIRED_2_IS_DIFF:false" "IO_HARDWIRED_3_IS_DIFF:false" "MODE_10V:false" "NGMUX0_HOLD_IS_USED:false" "NGMUX0_IS_USED:false" "NGMUX1_HOLD_IS_USED:false" \
"NGMUX1_IS_USED:false" "NGMUX2_HOLD_IS_USED:false" "NGMUX2_IS_USED:false" "NGMUX3_HOLD_IS_USED:false" "NGMUX3_IS_USED:false" "NGMUX_EXPOSE_HOLD:false" "PLL_DELAY:0" \
"PLL_EXPOSE_BYPASS:false" "PLL_EXPOSE_RESETS:false" "PLL_EXT_FB_GL:EXT_FB_GL0" "PLL_FB_SRC:CCC_INTERNAL" "PLL_IN_FREQ:50.000" "PLL_IN_SRC:OSC_50MHZ" "PLL_IS_USED:true" \
"PLL_LOCK_IND:1024" "PLL_LOCK_WND:32000" "PLL_SSM_DEPTH:0.5" "PLL_SSM_ENABLE:false" "PLL_SSM_FREQ:40" "PLL_SUPPLY_VOLTAGE:25_V" "PLL_VCO_TARGET:700" "RCOSC_1MHZ_IS_USED:false" \
"RCOSC_25_50MHZ_IS_USED:true" "VCOFREQUENCY:640.000" "XTLOSC_IS_USED:false" "Y0_IS_USED:false" "Y1_IS_USED:false" "Y2_IS_USED:false" "Y3_IS_USED:false"} 
sd_instantiate_component -sd_name $toplevel -component_name {FCCC_C0} -instance_name {FCCC_C0_0} 

create_and_configure_core -core_vlnv {Actel:SgCore:OSC:2.0.101} -component_name {OSC_C0} \
-params {"RCOSC_1MHZ_DRIVES_CCC:false" "RCOSC_1MHZ_DRIVES_FAB:false" "RCOSC_1MHZ_IS_USED:false" "RCOSC_25_50MHZ_DRIVES_CCC:1" "RCOSC_25_50MHZ_DRIVES_FAB:false" \
"RCOSC_25_50MHZ_IS_USED:1" "VOLTAGE_IS_1_2:true" "XTLOSC_DRIVES_CCC:false" "XTLOSC_DRIVES_FAB:false" "XTLOSC_FREQ:20.00" "XTLOSC_IS_USED:false" "XTLOSC_SRC:CRYSTAL"} 
sd_instantiate_component -sd_name $toplevel -component_name {OSC_C0} -instance_name {OSC_C0_0} 

sd_instantiate_macro -sd_name ${toplevel} -macro_name {AND2} -instance_name {AND2_0} 
sd_instantiate_macro -sd_name ${toplevel} -macro_name {SYSRESET} -instance_name {SYSRESET_0} 
sd_instantiate_macro -sd_name ${toplevel} -macro_name {LIVE_PROBE_FB} -instance_name {LIVE_PROBE_FB_0} 

sd_create_bus_port -sd_name ${toplevel} -port_name {LED} -port_direction {OUT} -port_range {[7:0]} 
sd_create_scalar_port -sd_name ${toplevel} -port_name {USER_BTN} -port_direction {IN}
sd_create_scalar_port -sd_name ${toplevel} -port_name {USER_LED} -port_direction {OUT}

sd_connect_pins -sd_name ${toplevel} -pin_names {"OSC_C0_0:RCOSC_25_50MHZ_CCC_OUT" "FCCC_C0_0:RCOSC_25_50MHZ_CCC_IN"} 
sd_connect_pins -sd_name ${toplevel} -pin_names {"FCCC_C0_0:LOCK" "AND2_0:A"} 
sd_connect_pins -sd_name ${toplevel} -pin_names {"AND2_0:Y" "count24_0:RESETn"} 
sd_connect_pins -sd_name ${toplevel} -pin_names {"FCCC_C0_0:GL0" "count24_0:CLK"} 
sd_connect_pins -sd_name ${toplevel} -pin_names {"SYSRESET_0:POWER_ON_RESET_N" "AND2_0:B"} 

sd_connect_pin_to_port -sd_name ${toplevel} -pin_name {count24_0:UP_DN} -port_name {USER_BTN} 
sd_create_pin_slices -sd_name ${toplevel} -pin_name {count24_0:Q} -pin_slices {"[23:16]"} 
sd_connect_pins -sd_name ${toplevel} -pin_names {"count24_0:Q[23:16]" "LED"} 

sd_connect_pin_to_port -sd_name ${toplevel} -pin_name {LIVE_PROBE_FB_0:PROBE_A} -port_name {USER_LED} 
sd_mark_pins_unused -sd_name ${toplevel} -pin_names {LIVE_PROBE_FB_0:PROBE_B} 

generate_component -component_name ${toplevel} -recursive 0 
build_design_hierarchy 
set_root -module ${toplevel} 
save_project 

puts "-------------------------------------------------------------------------"
puts "------------------------ORGANISING TESTBENCH-----------------------------"
puts "-------------------------------------------------------------------------"
import_files \
         -convert_EDN_to_HDL 0 \
         -library {work} \
         -stimulus ${import_dir}/user_testbench.vhd
build_design_hierarchy 
organize_tool_files -tool {SIM_PRESYNTH}   -file ${project_dir}/stimulus/user_testbench.vhd -module ${toplevel} -input_type {stimulus} 
organize_tool_files -tool {SIM_POSTSYNTH}  -file ${project_dir}/stimulus/user_testbench.vhd -module ${toplevel} -input_type {stimulus} 
organize_tool_files -tool {SIM_POSTLAYOUT} -file ${project_dir}/stimulus/user_testbench.vhd -module ${toplevel} -input_type {stimulus} 
import_files \
         -convert_EDN_to_HDL 0 \
         -library {work} \
         -simulation ${import_dir}/vhdl_run.do \
         -simulation ${import_dir}/vhdl_wave.do 
save_project 
run_tool -name {GENERATE_MEMORY_MAP} 

puts "-------------------------------------------------------------------------"
puts "--------------------APPLYING DESIGN CONSTRAINTS--------------------------"
puts "-------------------------------------------------------------------------"
import_files \
         -convert_EDN_to_HDL 0 \
         -io_pdc ${import_dir}/Fabric_Top.pdc
         
run_tool -name {CONSTRAINT_MANAGEMENT} 
organize_tool_files -tool {PLACEROUTE} -file ${project_dir}/constraint/io/Fabric_Top.pdc -module ${toplevel} -input_type {constraint} 
set_device_simple -family {SmartFusion2} -die {M2S010} -package {400 VF} -speed {STD} -die_voltage {1.2} -part_range {COM} \
-adv_options {DSW_VCCA_VOLTAGE_RAMP_RATE:100_MS} -adv_options {IO_DEFT_STD:LVCMOS 3.3V} -adv_options {PLL_SUPPLY:PLL_SUPPLY_33} \
-adv_options {RESERVEMIGRATIONPINS:1} -adv_options {RESTRICTPROBEPINS:1} -adv_options {RESTRICTSPIPINS:0} -adv_options {SYSTEM_CONTROLLER_SUSPEND_MODE:0} \
-adv_options {TEMPR:COM} -adv_options {VCCI_1.2_VOLTR:COM} -adv_options {VCCI_1.5_VOLTR:COM} -adv_options {VCCI_1.8_VOLTR:COM} -adv_options {VCCI_2.5_VOLTR:COM} \
-adv_options {VCCI_3.3_VOLTR:COM} -adv_options {VOLTR:COM} 
derive_constraints_sdc 
save_project 

puts "-------------------------------------------------------------------------"
puts "-----------------------------SYNTHESIS-----------------------------------"
puts "-------------------------------------------------------------------------"
run_tool -name {SYNTHESIZE}

puts "-------------------------------------------------------------------------"
puts "--------------------------PLACE AND ROUTE--------------------------------"
puts "-------------------------------------------------------------------------"
run_tool -name {PLACEROUTE}

puts "-------------------------------------------------------------------------"
puts "--------------------GENERATING PROGRAMMING FILES-------------------------"
puts "-------------------------------------------------------------------------"
run_tool -name {GENERATEPROGRAMMINGDATA}
run_tool -name {GENERATEPROGRAMMINGFILE} 

puts "-------------------------------------------------------------------------"
puts "--------------------------TIMING ANALYSIS--------------------------------"
puts "-------------------------------------------------------------------------"
configure_tool -name {VERIFYTIMING} -params {CONSTRAINTS_COVERAGE:1} -params {FORMAT:XML} -params {MAX_EXPANDED_PATHS_TIMING:1} -params {MAX_EXPANDED_PATHS_VIOLATION:0} \
-params {MAX_PARALLEL_PATHS_TIMING:1} -params {MAX_PARALLEL_PATHS_VIOLATION:1} -params {MAX_PATHS_INTERACTIVE_REPORT:1000} -params {MAX_PATHS_TIMING:5} \
-params {MAX_PATHS_VIOLATION:20} -params {MAX_TIMING_FAST_HV_LT:1} -params {MAX_TIMING_MULTI_CORNER:1} -params {MAX_TIMING_SLOW_LV_HT:1} \
-params {MAX_TIMING_VIOLATIONS_FAST_HV_LT:1} -params {MAX_TIMING_VIOLATIONS_MULTI_CORNER:1} -params {MAX_TIMING_VIOLATIONS_SLOW_LV_HT:1} \
-params {MIN_TIMING_FAST_HV_LT:1} -params {MIN_TIMING_MULTI_CORNER:1} -params {MIN_TIMING_SLOW_LV_HT:1} -params {MIN_TIMING_VIOLATIONS_FAST_HV_LT:1} \
-params {MIN_TIMING_VIOLATIONS_MULTI_CORNER:1} -params {MIN_TIMING_VIOLATIONS_SLOW_LV_HT:1} -params {SLACK_THRESHOLD_VIOLATION:0.0} -params {SMART_INTERACTIVE:true} 
run_tool -name {VERIFYTIMING} 

puts "-------------------------------------------------------------------------"
puts "----------------------EXPORT PROGRAMMING FILES---------------------------"
puts "-------------------------------------------------------------------------"

export_pin_reports \
         -export_dir ${project_dir}/designer/${toplevel}/export \
         -pin_report_by_name 1 \
         -pin_report_by_pkg_pin 1 \
         -bank_report 1 \
         -io_report 1 
export_prog_job \
         -job_file_name ${prog_filename} \
         -export_dir ${project_dir}/designer/${toplevel}/export \
         -bitstream_file_type {TRUSTED_FACILITY} \
         -bitstream_file_components {FABRIC} \
         -include_plaintext_passkey 0 \
         -design_bitstream_format {STP} \
         -prog_optional_procedures {} \
         -sanitize_envm 0 
export_bitstream_file \
         -file_name ${prog_filename} \
         -export_dir ${project_dir}/designer/${toplevel}/export \
         -format {STP PPD} \
         -for_ihp 0 \
         -limit_SVF_file_size 0 \
         -limit_SVF_file_by_max_filesize_or_vectors {} \
         -svf_max_filesize {} \
         -svf_max_vectors {} \
         -master_file 0 \
         -master_file_components {} \
         -encrypted_uek1_file 0 \
         -encrypted_uek1_file_components {} \
         -encrypted_uek2_file 0 \
         -encrypted_uek2_file_components {} \
         -trusted_facility_file 1 \
         -trusted_facility_file_components {FABRIC} \
         -add_golden_image 0 \
         -golden_image_address {} \
         -golden_image_design_version {} \
         -add_update_image 0 \
         -update_image_address {} \
         -update_image_design_version {} \
         -serialization_stapl_type {SINGLE} \
         -serialization_target_solution {FLASHPRO_3_4_5} \
         -master_include_plaintext_passkey 0 \
         -uek1_include_plaintext_passkey 0 \
         -uek2_include_plaintext_passkey 0 \
         -sanitize_envm 0 
export_smart_debug_data \
         -file_name ${prog_filename} \
         -export_dir ${project_dir}/designer/${toplevel}/export \
         -probes 1 \
         -package_pins 0 \
         -memory_blocks 1 \
         -security_data 1 \
         -security_data 0 \
         -chain 1 \
         -programmer_settings 1 \
         -ios_states 1 \
         -generate_bitstream 0 \
         -bitstream_format {PPD} \
         -bitstream_security 0 \
         -bitstream_fabric 0 \
         -bitstream_envm 0 \
         -master_include_plaintext_passkey 0 
save_project
