--------------------------------------------------------------------------------
-- Company: Microsemi SoC Products Group
--
-- File: user_testbench.vhd
-- File history:
--      1.0: July 23, 2016: Written
--      2.0: Nov. 30, 2018: USER_BTN added
--      3.0: Feb. 10, 2021: LED added
--      <Revision number>: <Date>: <Comments>
--
-- Description: 
--
-- Testbench for SmartFusion2 Fabric / Probe design lab
--
-- Targeted device: <Family::SmartFusion2> 
-- Author: Luca Cattaneo
--
--------------------------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

entity testbench is
end testbench;

architecture behavioral of testbench is

	signal USER_BTN_in: std_logic;
	signal RST_SW_in: std_logic;
    signal LED: std_logic_vector(7 downto 0);

	component Fabric_Top
    	-- Port list
    	port(
        	-- Inputs
            USER_BTN : in  std_logic;
        	DEVRST_N : in  std_logic;
       		-- Outputs
       	 	LED      : out std_logic_vector(7 downto 0)
       	 );
	end component Fabric_Top;


begin

RST_SW_in <= '1', '0' after 10 ns, '1' after 20 ns;

USER_BTN_in <= '1', '0' after 510 us, '1' after 990 us;

    -- Instantiate Unit Under Test:  Fabric_Top
    Fabric_Top_0 : Fabric_Top
        port map( 
            -- Inputs
	    DEVRST_N => RST_SW_in,
        USER_BTN => USER_BTN_in,

            -- Outputs
            LED => LED);

end behavioral;
