#---------------------------------------------------------------------------
# ModelSim command file for SmartFusion2 Day 1 training class
# This file is used with the SF2_Fab_Probe design
# File name: vhdl_run.do
# Author: Tim McCarthy
# Revision History
# Rev		Comments			            Date
# 1.0		Created				            July 25, 2016
# 2.0       Updated for Libero 11.8         March 1, 2017
#           Added support for Future Electronics Creative boards
# 2.1       Updated for Libero 11.9         November 8, 2018
# 2.2		Updated for Libero 12.1			May 3, 2019
# 2.3		Updated for Libero 12.4			Aug 18, 2020  
# 2.4		Updated for Libero 12.5			Oct 2, 2020   
# 2.5		Updated for Libero 12.6			Feb 10, 2021  
#----------------------------------------------------------------------------
quietly set ACTELLIBNAME SmartFusion2
# Edit the next line to match the location of your Libero project
quietly set PROJECT_DIR "C:/Mchpprj/SmartFusion2_Fabric"
# Edit the next line to match the Libero installation location of your PC
quietly set INSTALL_DIR "C:/Libero_SoC_v12.6"

if {[file exists presynth/_info]} {
   echo "INFO: Simulation library presynth already exists"
} else {
   vlib presynth
}
vmap presynth presynth
#vmap SmartFusion2 "${INSTALL_DIR}/Designer/lib/modelsim/precompiled/vhdl/SmartFusion2"
vmap SmartFusion2 "${INSTALL_DIR}/Designer/lib/modelsim/precompiled/vlog/SmartFusion2"

vcom -2008 -explicit  -work presynth "${PROJECT_DIR}/component/work/FCCC_C0/FCCC_C0_0/FCCC_C0_FCCC_C0_0_FCCC.vhd"
vcom -2008 -explicit  -work presynth "${PROJECT_DIR}/component/work/FCCC_C0/FCCC_C0.vhd"
vcom -2008 -explicit  -work presynth "${PROJECT_DIR}/component/work/OSC_C0/OSC_C0_0/OSC_C0_OSC_C0_0_OSC.vhd"
vcom -2008 -explicit  -work presynth "${PROJECT_DIR}/component/work/OSC_C0/OSC_C0.vhd"
vcom -2008 -explicit  -work presynth "${PROJECT_DIR}/hdl/count24.vhd"
vcom -2008 -explicit  -work presynth "${PROJECT_DIR}/component/work/Fabric_Top/Fabric_Top.vhd"
vcom -2008 -explicit  -work presynth "${PROJECT_DIR}/stimulus/user_testbench.vhd"

vsim -L SmartFusion2 -L presynth -L COREUART_LIB  -t 1ps presynth.testbench
do "vhdl_wave.do"

run 1000 us

force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(15) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(14) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(13) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(12) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(11) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(10) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(9) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(8) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(7) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(6) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(5) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(4) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(3) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(2) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(1) 1 0
force -freeze sim:/testbench/Fabric_Top_0/count24_0/Q_int(0) 1 0

run 1000 us
